%{
/* $Header: /home/pm3fb/xftimings2pm3/xft2pm3-lex.l,v 1.2 2001/07/06 08:55:18 dolbeau Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include "xftimings2pm3.h"
#include "xft2pm3-par.h"
%}

%%

Mode                  return MODE;

ModeLine              return MODELINE;

DotClock              return DOTCLOCK;

HTimings              return HTIMINGS;

VTimings              return VTIMINGS;

EndMode               return ENDMODE;

[0-9]+\.[0-9]+        yylval.flottant = atof(yytext); return FLOTTANT;

[0-9]+                yylval.entier = atoi(yytext); return ENTIER;

"#"[^\n]*"\n"         /* eat up comment */

[ \t\n]+              /* eat up whitespace */

Flags                 return FLAGS;

\"Interlace\"         return INTERLACED; /* XF4 flags */

Interlace         return INTERLACED; /* XF3 flags */

\"DoubleScan\"        return DOUBLESCAN; /* XF4 flags */

"\"-HSync\""          yylval.sk = sync_low; return HSKIND; /* XF4 flags */

"\"+HSync\""          yylval.sk = sync_high; return HSKIND; /* XF4 flags */

"\"-VSync\""          yylval.sk = sync_low; return VSKIND; /* XF4 flags */

"\"+VSync\""          yylval.sk = sync_high; return VSKIND; /* XF4 flags */

"-HSync"          yylval.sk = sync_low; return HSKIND; /* XF3 flags */

"+HSync"          yylval.sk = sync_high; return HSKIND; /* XF3 flags */

"-VSync"          yylval.sk = sync_low; return VSKIND;  /* XF3 flags */

"+VSync"          yylval.sk = sync_high; return VSKIND; /* XF3 flags */

\"Composite\"         return COMPOSITE; /* XF4 flags */

\"-CSync\"            yylval.sk = sync_low; return CSKIND; /* XF4 flags */

"\"+CSync\""          yylval.sk = sync_high; return CSKIND; /* XF4 flags */

HSkew                 return HSKEW;

VScan                 return VSCAN;

\"[^\n \t]+\"      { yylval.chaine = malloc(1 + yyleng); (void)strncpy(yylval.chaine, yytext, yyleng); yylval.chaine[yyleng] = 0; return MODE_NAME; }

true                  yylval.entier = 1; return BOOL;

false                 yylval.entier = 0; return BOOL;

.                     fprintf(stderr, "%s", yytext);

%%
