%{
/* $Header: /home/pm3fb/xftimings2pm3/xft2pm3-par.y,v 1.3 2001/07/06 08:55:18 dolbeau Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include "xftimings2pm3.h"
%}

%union {
  sync_kind_t sk;
  char* chaine;
  unsigned long entier;
  double flottant;
}
 

%token MODE MODELINE
%token DOTCLOCK
%token ENDMODE
%token <chaine> MODE_NAME
%token HTIMINGS
%token VTIMINGS
%token <entier> ENTIER
%token <flottant> FLOTTANT
%token FLAGS
%token <sk> HSKIND
%token <sk> VSKIND
%token <sk> CSKIND
%token INTERLACED
%token DOUBLESCAN
%token COMPOSITE
%token HSKEW
%token VSCAN
%token <entier> BOOL

%%

input: /* empty */
	| fullmodeXF4 input { }
        | fullmodeXF3 input { }

fullmodeXF4: MODE MODE_NAME
	DOTCLOCK FLOTTANT
        HTIMINGS ENTIER ENTIER ENTIER ENTIER
        VTIMINGS ENTIER ENTIER ENTIER ENTIER
	flaglist
	adjlist
	ENDMODE
	{
	  char video[256], dis_s[256];
	  int disable = 0;
	  
   	    printf("/* Generated mode : %s */\n", $2);
	    sprintf(video, "PM3VideoControl_ENABLE%s%s%s",
		   ($<entier>15 & F_HSYNC_HIGH) ? "|PM3VideoControl_HSYNC_ACTIVE_HIGH" :
                                                  "|PM3VideoControl_HSYNC_ACTIVE_LOW",
		   ($<entier>15 & F_VSYNC_HIGH) ? "|PM3VideoControl_VSYNC_ACTIVE_HIGH" :
                                                  "|PM3VideoControl_VSYNC_ACTIVE_LOW",
		    "|PM3VideoControl_PIXELSIZE_8BIT");
	    if ($<entier>15 & (F_COMPOSITE | F_INTERLACED | F_DOUBLESCAN | F_HSKEW | F_VSCAN))
	      {
		sprintf(dis_s, "\n   NOT SUPPORTED:%s%s%s%s%s */",
			$<entier>15 & F_COMPOSITE ? " CompositeSync" : "",
			$<entier>15 & F_INTERLACED ? " Interlaced" : "",
			$<entier>15 & F_DOUBLESCAN ? " DoubleScan" : "",
			$<entier>15 & F_HSKEW ? " HorizontalSkewing" : "",
			$<entier>15 & F_VSCAN ? " VerticalScan" : "");
		disable = 1;
	      }
	    printf("%s  {%s, {%d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %s}}, %s\n",
		   disable ? "/* NOT SUPPORTED\n" : "",
		   $2,
		   (long)(1000. * $4), $6, $11,
		   $7 - $6, $8 - $6, $9 - $6, $9,
		   $12 - $11, $13 - $11, $14 - $11, $14,
		   $6, 0, 8, /* always 8 bits */
		   video,
		   disable ? dis_s : "");
	}

fullmodeXF3: MODELINE MODE_NAME FLOTTANT ENTIER ENTIER ENTIER ENTIER ENTIER ENTIER ENTIER ENTIER flagsublist
             {
	       char video[256], dis_s[256];
	       int disable = 0;
	       
	       printf("/* Generated mode : %s */\n", $2);
	       sprintf(video, "PM3VideoControl_ENABLE%s%s%s",
		       ($<entier>12 & F_HSYNC_HIGH) ? "|PM3VideoControl_HSYNC_ACTIVE_HIGH" :
		       "|PM3VideoControl_HSYNC_ACTIVE_LOW",
		       ($<entier>12 & F_VSYNC_HIGH) ? "|PM3VideoControl_VSYNC_ACTIVE_HIGH" :
		       "|PM3VideoControl_VSYNC_ACTIVE_LOW",
		       "|PM3VideoControl_PIXELSIZE_8BIT");
	       if ($<entier>12 & (F_COMPOSITE | F_INTERLACED | F_DOUBLESCAN | F_HSKEW | F_VSCAN))
		 {
		   sprintf(dis_s, "\n   NOT SUPPORTED:%s%s%s%s%s */",
			   $<entier>15 & F_COMPOSITE ? " CompositeSync" : "",
			   $<entier>15 & F_INTERLACED ? " Interlaced" : "",
			   $<entier>15 & F_DOUBLESCAN ? " DoubleScan" : "",
			   $<entier>15 & F_HSKEW ? " HorizontalSkewing" : "",
			   $<entier>15 & F_VSCAN ? " VerticalScan" : "");
		   disable = 1;
		 }
	       printf("%s  {%s, {%d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %s}}, %s\n",
		      disable ? "/* NOT SUPPORTED\n" : "",
		      $2,
		      (long)(1000. * $3), $4, $8,
		      $5 - $4, $6 - $4, $7 - $4, $7,
		      $9 - $8, $10 - $8, $11 - $8, $11,
		      $4, 0, 8, /* always 8 bits */
		      video,
		      disable ? dis_s : "");
	       
	       
	     }

flaglist: /* empty */ { $<entier>$ = 0; }
        | FLAGS flagsublist flaglist { $<entier>$ = $<entier>2 | $<entier>3; }

flagsublist: /* empty */ { $<entier>$ = 0; }
	| INTERLACED flagsublist { $<entier>$ = F_INTERLACED | $<entier>2; }
	| DOUBLESCAN flagsublist { $<entier>$ = F_DOUBLESCAN | $<entier>2;}
	| HSKIND flagsublist { $<entier>$ = ($1 == sync_high ? F_HSYNC_HIGH : F_HSYNC_LOW ) | $<entier>2; }
	| VSKIND flagsublist { $<entier>$ = ($1 == sync_high ? F_VSYNC_HIGH : F_VSYNC_LOW ) | $<entier>2; }
	| COMPOSITE flagsublist { $<entier>$ = F_COMPOSITE | $<entier>2; }
	| CSKIND flagsublist { $<entier>$ = ($1 == sync_high ? F_CSYNC_HIGH : F_CSYNC_LOW ) | $<entier>2; }

adjlist: /* empty */ { $<entier>$ = 0; }
	| HSKEW adjlist { $<entier>$ = F_HSKEW | $<entier>2; }
	| VSCAN adjlist { $<entier>$ = F_VSCAN | $<entier>2; }

%%

int
yywrap()
{
  return(1);
}

yyerror (char *s)
{
  fprintf (stderr, "%s\n", s);
}
